<?php
/*
   Plugin Name: StatComm (StatPress Community)
   Plugin URI: http://www.wpgetready.com/downloads
   Description: Powerful statistics and traffic information directly to your blog.
   Version: 1.6.81
   Author: Fernando Zorrilla SM
   Author URI: http://www.wpgetready.com

   Introduction: StatPress Community is a plugin for web statistics, based in their StatPress sucessors.

    V1.6.81:
    Fix: adjustment uasparser activation.
    V1.6.80:
    * Changed uaparser auto update to manual, so the user has complete control over the process and more reliable.

*/
     include(dirname(__FILE__). '/classes/mysql.php'); 			//database interface class
     include(dirname(__FILE__). '/classes/widget_toppost.php'); //widget class
     include(dirname(__FILE__). '/classes/widget_print.php'); 	//widget class
     include(dirname(__FILE__). '/classes/uasparser.php'); 		//parser class (abstract, not modify)
     include(dirname(__FILE__). '/classes/statcommparser.php'); //parser class based on uasparser
	 include(dirname(__FILE__). '/classes/settings.php'); 		//settings class based on Settings API
	 include(dirname(__FILE__). '/classes/utilities.php'); 		//common methods used in many classes.
     include(dirname(__FILE__). '/classes/geoipupdate.php'); 	//GeoCityLite updater
     include(dirname(__FILE__). '/classes/statcommspy.php'); 	//Statcomm Spy function  + Ajax
     include(dirname(__FILE__). '/classes/uaparserupdate.php'); //manual update option

    $options = get_option( 'statcomm_options' );
    $chk_geolocation =isset($options['chk_glc'])?$options['chk_glc']:'';

    if ($chk_geolocation)
    {
	 include(dirname(__FILE__). '/classes/geoip.php'); 		        //common methods used in many classes.
	 include(dirname(__FILE__). '/classes/geoipcity.php'); 		    //common methods used in many classes.
	 include(dirname(__FILE__). '/classes/geoipregionvars.php'); 	//common methods used in many classes.
    }

  $SPCM= new statPressCommunity();

  class statPressCommunity
  {
	const ROBOT = 'Robot'; //type of agent that identifies a robot bot/crawler
    //Define directory where the agents data and search terms are located
    private static $_parserDir ="";
	//Plugin constructor & initialization
   function __construct()
   {

        add_action('init', 			array(&$this,'loadTextDomain')); //add translation
        add_action('admin_menu', 	array(&$this,'addPages'));       //add menu pages
        add_action('send_headers', 	array(&$this,'statcommAppend')); //activate append records

		add_action('admin_init', 'settingsAPI::statcomm_admin_init'); //Settings API as a static class
		add_action('admin_init', array(&$this,'addDetailsStyle'));    //style initialization
        add_action( 'admin_print_styles', array(&$this,'genericAdminStyle') ); //generic style to administrator

        register_activation_hook(__FILE__, array(&$this, 'initTableAndOptions')); //Table creation and Options init

        add_action('wp_ajax_sctooltip_action', array(&$this, 'statcommSpyTooltip') );//Action for tooltip

		$exportnow = (isset($_GET['statcomm_action']) ? $_GET['statcomm_action'] : '');
		if ($exportnow=='exportnow')
          {
              $this->exportNow();
          }
   }

      /**
       * Generic style for admin (it add only new icon)
       */
      function genericAdminStyle() {

          //Generic style for plugin
          $css = plugin_dir_url(__FILE__) . 'css/statcomm.css';
          wp_register_style( 'statcomm-admin-style', $css , null, '1.0', 'screen' );
          wp_enqueue_style( 'statcomm-admin-style' );

          //Tooltip style. To keep functionality in one place, we decide to put this css with javascript
          $qtip = plugin_dir_url(__FILE__) . 'js/jquery.qtip.min.css';
          wp_register_style( 'statcomm-tooltip', $qtip , null, '1.0', 'screen' );
          wp_enqueue_style( 'statcomm-tooltip' );

          //Javascript for tooltip. jquery automatic loading since it is needed.
          wp_enqueue_script('qtip', plugin_dir_url(__FILE__) . 'js/jquery.qtip.min.js', array('jquery'), false, true);
          //Javascript detection
          wp_enqueue_script('sc-qtip', plugin_dir_url(__FILE__) . 'js/sc-tooltip.js', array('qtip'), false, true);

      }

  /**
   * Add pages to the main menu
   * 1.6.2: Updated menu to be compatible with WP 3.0
   * 1.6.5: Adding stylesheet to Details page
   */
  function addPages()
  {
      // add submenu
	  $options=settingsAPI::getOptions();
      $mincap = $options["cmb_capability"];
      if ($mincap == '')
      {
          $mincap = 'activate_plugins'; //admin by default minimum capability . Reference:http://codex.wordpress.org/Roles_and_Capabilities#Summary_of_Roles
      }

      $statcomm_style=add_menu_page('StatPress Community', 'StatComm', $mincap, "statComm",array(&$this, 'statcommMain'), plugins_url('images/statcomm-bw-16x16.png', __FILE__));
      add_submenu_page('statComm', __('Details'       ,'statcomm'), __('Details'       ,'statcomm'), $mincap, 'statComm/details',array (&$this, 'statcommDetails'));
	  $statcomm_spy  =add_submenu_page('statComm', __('Spy'           ,'statcomm'), __('Spy'           ,'statcomm'), $mincap, 'statComm/spy',array(&$this, 'statcommSpy'));
      add_submenu_page('statComm', __('Search'        ,'statcomm'), __('Search'        ,'statcomm'), $mincap, 'statComm/search', array(&$this, 'statcommSearch'));
      add_submenu_page('statComm', __('Export'        ,'statcomm'), __('Export'        ,'statcomm'), $mincap, 'statComm/export',array(&$this, 'statcommExport'));
      add_submenu_page('statComm', __('Options'       ,'statcomm'), __('Options'       ,'statcomm'), $mincap, 'statComm/options', array(&$this, 'statcommOptions'));
      add_submenu_page('statComm', __('User Agents'   ,'statcomm'), __('User Agents'   ,'statcomm'), $mincap, 'statComm/agents', array(&$this, 'statcommAgents'));
      add_submenu_page('statComm', __('HELP & Support','statcomm'), __('HELP & Support','statcomm'), $mincap, 'statComm/help', array(&$this, 'statcommHelp'));

      add_action( 'admin_print_styles-' . $statcomm_style, array(&$this,'statcommAdminStyle' ));
      add_action( 'admin_print_styles-' . $statcomm_spy, array(&$this,'statcommAdminStyle' ));

      /*For testing purposes
      $statcomm_spytest=add_submenu_page('statComm', __('Spy Testing','statcomm'), __('Spy Testing','statcomm'), $mincap, 'statComm/testspy', array(&$this, 'statcommSpyTooltip'));
      add_action( 'admin_print_styles-' . $statcomm_spytest, array(&$this,'statcommAdminStyle' ));
        */

      //1.6.60:special page only accesible when update Geolitecity.dat
      add_submenu_page('statComm/options', __('Options'       ,'statcomm'), __('Options'       ,'statcomm'), $mincap, 'statComm/glcupdate', array(&$this, 'statcommGLCUpdate'));
      //1.6.80:special page only accesible when update UAS parser
      add_submenu_page('statComm/options', __('Options'       ,'statcomm'), __('Options'       ,'statcomm'), $mincap, 'statComm/uasupdate', array(&$this, 'statcommUASUpdate'));
  }

    function statcommGLCUpdate()
    {
        utilities::fl("Begin updating Maxmind...");
        $gu= new geoliteUpdater();
        $gu->update(); //try to update
    }

    function statcommUASUpdate()
    {
        utilities::fl("Begin updating UAS fiel...");
        $gu= new uaparserUpdater();
        $gu->update(); //try to update

    }

      function statcommSpyTooltip()
      {
        $id= isset($_GET['id'])?$_GET['id']:"";
        if ($id=="")
        {
            echo "<b>". __("Error: not IP provided","statcomm") ."</b>";
            die();
        }
            
        statcommSpy::makeTooltipMsg($id);
        die();
      }

  /*
   * 1.6.5:add custom stylesheet for Details Page ONLY.
   * This style is used for displaying flags properly
   */
  function addDetailsStyle()
  {
      /** Register */
      wp_register_style('statcomm-flags', plugins_url('css/statcomm-flags.css', __FILE__), array());
      wp_register_style('statcomm-os', plugins_url('css/statcomm-os.css', __FILE__), array());
      wp_register_style('statcomm-uas', plugins_url('css/statcomm-uas.css', __FILE__), array());
  }

      /**
       * 1.6.5: Register custom style for proper flag into Details page.
       */
  function statcommAdminStyle()
  {
      /** Enqueue */
      wp_enqueue_style('statcomm-flags');
      wp_enqueue_style('statcomm-os');
      wp_enqueue_style('statcomm-uas');
  }


/**
 * Shows help.
 */
  function statcommHelp()
  {
  ?>
  <div class='wrap'><h2><?php _e('HELP', 'statcomm');?></h2><?php require_once("help-page/help.php"); ?></div>
  <?php
  }

  /**
  *  1.6.4:Improved Options using Settings API
  */
  function statcommOptions()
  {
	settingsAPI::statcomm_option_page();
	return;
  }

/**
 * Export data to CSV format.
 * To improve from 1.6.4
 */
      function statcommExport()
      {
?>
  <div class='wrap'><h2><?php
          _e('Export stats to text file', 'statcomm');
?> (csv)</h2>
  <form method=get><table>
  <tr><td><?php
          _e('From', 'statcomm');
?></td><td><input type=text name=from> (YYYYMMDD)</td></tr>
  <tr><td><?php
          _e('To', 'statcomm');
?></td><td><input type=text name=to> (YYYYMMDD)</td></tr>
  <tr><td><?php
          _e('Fields delimiter', 'statcomm');
?></td><td><select name=del><option>,</option><option>;</option><option>|</option></select></tr>
  <tr><td></td><td><input type=submit value=<?php
          _e('Export', 'statcomm');
?>></td></tr>
  <input type=hidden name=page value=statpress><input type=hidden name=statcomm_action value=exportnow>
  </table></form>
  </div>
<?php
      }

/**
 * Export data from database to datafiles.
 * 1.6.0 - Fixed missing id field
 */
      function exportNow()
      {
          $mySql=new mySql();
          $filename = get_bloginfo('title') . "-statpress_" . $_GET['from'] . "-" . $_GET['to'] . ".csv";
          header('Content-Description: File Transfer');
          header("Content-Disposition: attachment; filename=$filename");
          header('Content-Type: text/plain charset=' . get_option('blog_charset'), true);
          $qryExport= "SELECT * FROM #table# WHERE date>='" . (date("Ymd", strtotime(mb_substr ($_GET['from'], 0, 8)))) . "' AND date<='" . (date("Ymd", strtotime(mb_substr ($_GET['to'], 0, 8)))) . "'";
          $qry = $mySql->getResult($qryExport);
          $del =mb_substr ($_GET['del'], 0, 1);
          print "id" . $del . "date" . $del . "time" . $del . "ip" . $del . "urlrequested" . $del . "agent" . $del . "referrer" . $del . "search" . $del . "nation" . $del . "os" . $del . "browser" . $del . "searchengine" . $del . "spider" . $del . "feed\n";
          foreach ($qry as $rk)
          {
              print '"' . $rk->id . '"' . $del . '"' . $rk->date . '"' . $del . '"' . $rk->time . '"' . $del . '"' . $rk->ip . '"' . $del . '"' . $rk->urlrequested . '"' . $del . '"' . $rk->agent . '"' . $del . '"' . $rk->referrer . '"' . $del . '"' . urldecode($rk->search) . '"' . $del . '"' . $rk->nation . '"' . $del . '"' . $rk->os . '"' . $del . '"' . $rk->browser . '"' . $del . '"' . $rk->searchengine . '"' . $del . '"' . $rk->spider . '"' . $del . '"' . $rk->feed . '"' . "\n";
          }
          die();
      }

/**
 * Constants definitions
 * Update: statcommMain organized in much more manageable modules. Much improved documentation.
 */
      function statcommMain()
      {
		 //Main Header
		 $this->drawTableOverview();

         //Graphic Char
		  $this->drawChart();

          //Last Hits Table
		 $this->lastHitTable();

          //Last search terms table
          $this->lastSearchTerms();

		  //Last referrers table
		  $this->lastReferrers();

          //Last agent table
		  $this->lastAgents();

          //Last pages table
          $this->lastPages();

          //Last spiders table
          $this->lastSpiders();

		  $this->footerMainPage();
      }

		/**
		 * Main header for Main Page
		 * Currently one the most complex with around 140 of code and also around
		 * 21 queries(!)Can be improved or reduced the queries amount? A:YES rescheduled for 1.8.x
		 * To improve: separation data from structure.Render is a process, calculation is another.
		 */
		private function drawTableOverview()
		{
   		  $mySql= new mySql();
          $unique_color = "#114477";
          $web_color = "#3377B6";
          $rss_color = "#f38f36";
          $spider_color = "#83b4d8";
          $lastmonth = $this-> statcommLastMonth();
          $thismonth = gmdate('Ym', current_time('timestamp'));
          $yesterday = gmdate('Ymd', current_time('timestamp') - 86400);
          $today = gmdate('Ymd', current_time('timestamp'));
          $tlm[0] =mb_substr($lastmonth, 0, 4);
          $tlm[1] = mb_substr($lastmonth, 4, 2);

		  //Draw Header
          print "<div class='wrap'><h2>" . __('Overview', 'statcomm') . "</h2>";
          print "<table class='widefat'><thead><tr>
  <th scope='col'></th>
  <th scope='col'>" . __('Total', 'statcomm') . "</th>
  <th scope='col'>" . __('Last month', 'statcomm') . "<br /><font size=1>" . gmdate('M, Y', gmmktime(0, 0, 0, $tlm[1], 1, $tlm[0])) . "</font></th>
  <th scope='col'>" . __('This month', 'statcomm') . "<br /><font size=1>" . gmdate('M, Y', current_time('timestamp')) . "</font></th>
  <th scope='col'>" . __('Target', 'statcomm') . " " . __('This month', 'statcomm') . "<br /><font size=1>" . gmdate('M, Y', current_time('timestamp')) . "</font></th>
  <th scope='col'>" . __('Yesterday', 'statcomm') . "<br /><font size=1>" . gmdate('d M, Y', current_time('timestamp') - 86400) . "</font></th>
  <th scope='col'>" . __('Today', 'statcomm') . "<br /><font size=1>" . gmdate('d M, Y', current_time('timestamp')) . "</font></th>
  </tr></thead>
  <tbody id='the-list'>";
		  //**************
          // Visitors Row
          //**************
          print "<tr><td><div style='background:$unique_color;width:10px;height:10px;float:left;margin-top:4px;margin-right:5px;'></div>" . __('Visitors', 'statcomm') . "</td>";
          $qry_total = $mySql->getRow(mySql::QRY_Visitors);
          print "<td>" . $qry_total->visitors . "</td>\n";
		  //Visitors: total last month
          $qry_lmonth = $mySql->getRow(mySql::QRY_VisitorsMonth, mysql_real_escape_string($lastmonth));
          print "<td>" . $qry_lmonth->visitors . "</td>\n";
		  //Visitors: total this month
          $qry_tmonth = $mySql->getRow(mySql::QRY_VisitorsMonth, mysql_real_escape_string($thismonth));

          //This month % variation
          print "<td>" . $qry_tmonth->visitors . $this->calcPorcVar ($qry_tmonth->visitors,$qry_lmonth->visitors) . "</td>\n";
          print "<td>" . $this->calcAvgMonth($qry_tmonth->visitors,$qry_lmonth->visitors) . "</td>\n";

		  //Visits yesterday
		  $qry_y = $mySql->getRow(mySql::QRY_VisitorsDay, mysql_real_escape_string($yesterday));
          print "<td>" . $qry_y->visitors . "</td>\n";

		  //Visits today
		  $qry_t = $mySql->getRow(mySql::QRY_VisitorsDay, mysql_real_escape_string($today));
          print "<td>" . $qry_t->visitors . "</td>\n</tr>";

		  //**************
          //Pageviews Row
          //**************
          print "<tr><td><div style='background:$web_color;width:10px;height:10px;float:left;margin-top:4px;margin-right:5px;'></div>" . __('Pageviews', 'statcomm') . "</td>";

		  //Total pageviews
		  $qry_total = $mySql->getRow(mySql::QRY_PageViews);
          print "<td>" . $qry_total->pageview . "</td>\n";

          //Last month pageviews
		  $qry_lmonth = $mySql->getRow(mySql::QRY_PageViewsMonth, mysql_real_escape_string($lastmonth));
          print "<td>" . $qry_lmonth->pageview . "</td>\n";

          //This month pageviews
		  $qry_tmonth = $mySql->getRow(mySql::QRY_PageViewsMonth, mysql_real_escape_string($thismonth));

          //Pageviews calculated target
          print "<td>" . $qry_tmonth->pageview . $this->calcPorcVar ($qry_tmonth->pageview,$qry_lmonth->pageview ) . "</td>\n";
          print "<td>" . $this->calcAvgMonth ($qry_tmonth->pageview,$qry_lmonth->pageview ) . "</td>\n";

		  //Yesterday pageviews
		  $qry_y =$mySql->getRow(mySql::QRY_PageViewsDay, mysql_real_escape_string($yesterday));
          print "<td>" . $qry_y->pageview . "</td>\n";

		  //Today pageviews
		  $qry_t =$mySql->getRow(mySql::QRY_PageViewsDay, mysql_real_escape_string($today));
          print "<td>" . $qry_t->pageview . "</td>\n</tr>";

		  //**************
          //Spiders Row
          //**************
          print "<tr><td><div style='background:$spider_color;width:10px;height:10px;float:left;margin-top:4px;margin-right:5px;'></div>" . __('Spiders', 'statcomm') . "</td>";

		  //Spiders totals overall
		  $qry_total =$mySql->getRow(mySql::QRY_Spiders);
          print "<td>" . $qry_total->spiders . "</td>\n";

          //Spiders last month
		  $qry_lmonth =$mySql->getRow(mySql::QRY_SpidersMonth, mysql_real_escape_string($lastmonth));
          print "<td>" . $qry_lmonth->spiders . "</td>\n";

          //Spiders this month
		  $qry_tmonth =$mySql->getRow(mySql::QRY_SpidersMonth, mysql_real_escape_string($thismonth));

          //Spiders estimated target
          print "<td>" . $qry_tmonth->spiders . $this->calcPorcVar ($qry_tmonth->spiders,$qry_lmonth->spiders) . "</td>\n";
          print "<td>" . $this->calcAvgMonth ($qry_tmonth->spiders,$qry_lmonth->spiders) . "</td>\n";

          //Spiders yesterday
		  $qry_y =$mySql->getRow(mySql::QRY_SpidersDay, mysql_real_escape_string($yesterday));
          print "<td>" . $qry_y->spiders . "</td>\n";

          //Spiders today
		  $qry_t =$mySql->getRow(mySql::QRY_SpidersDay, mysql_real_escape_string($today));
          print "<td>" . $qry_t->spiders . "</td>\n</tr>";

          //**************
          //Feeds Row
          //**************
          print "<tr><td><div style='background:$rss_color;width:10px;height:10px;float:left;margin-top:4px;margin-right:5px;'></div>" . __('Feeds', 'statcomm') . "</td>";

		  //Total feeds overall
		  $qry_total =$mySql->getRow(mySql::QRY_Feeds);
          print "<td>" . $qry_total->feeds . "</td>\n";

          //Feeds last month
		  $qry_lmonth =$mySql->getRow(mySql::QRY_FeedsMonth, mysql_real_escape_string($lastmonth));
          print "<td>" . $qry_lmonth->feeds . "</td>\n";

          //Feeds this month
		  $qry_tmonth =$mySql->getRow(mySql::QRY_FeedsMonth, mysql_real_escape_string($thismonth));

          //Feeds estimated target
          print "<td>" . $qry_tmonth->feeds .   $this->calcPorcVar ($qry_tmonth->feeds,$qry_lmonth->feeds) . "</td>\n";
          print "<td>" . $this->calcAvgMonth ($qry_tmonth->feeds,$qry_lmonth->feeds) . "</td>\n";

		  //Feeds yesterday
		  $qry_y =$mySql->getRow(mySql::QRY_FeedsDaily, mysql_real_escape_string($yesterday));
          print "<td>" . $qry_y->feeds . "</td>\n";

		  //Feeds today
		  $qry_t =$mySql->getRow(mySql::QRY_FeedsDaily, mysql_real_escape_string($today));
          print "<td>" . $qry_t->feeds . "</td>\n";

          print "</tr></table><br />\n\n";
		}

		/**
		 * Draw main chart
		 * To improve: color would be configurable on incoming versions
		 */
		private function drawChart()
		{
			  $unique_color = "#114477";
	          $web_color = "#3377B6";
	          $rss_color = "#f38f36";
	          $spider_color = "#83b4d8";

			  $mySql= new mySql();
			  $options = settingsAPI::getOptions();
			  $gdays = $options['cmb_overview_graph']; //get day numbers. Watchout data has to be numeric.
	          $gdays = ($gdays == 0)? 20: $gdays;
	          $start_of_week = get_option('start_of_week');
	          print '<table width="100%" border="0"><tr>';

	          $qry =$mySql->getRow(mySql::QRY_MaxPageViews,gmdate('Ymd', current_time('timestamp') - 86400 * $gdays));

	          $maxxday =isset($qry->pageview)?$qry->pageview:0;
	          $maxxday= ($maxxday ==0)?1:$maxxday;
	          // Y
	          $gd = (90 / $gdays) . '%';


	          //Loop for every day depending on settings
	          for ($gg = $gdays - 1; $gg >= 0; $gg--)
	          {
	              //TOTAL VISITORS
	              $qry_visitors =$mySql->getRow(mySql::QRY_UsersDay,gmdate('Ymd', current_time('timestamp') - 86400 * $gg));
	              $px_visitors = round($qry_visitors->total * 100 / $maxxday);

	              //TOTAL PAGEVIEWS (we do not delete the uniques, this is falsing the info.. uniques are not different visitors!)
				  $qry_pageviews =$mySql->getRow(mySql::QRY_TotPageViews,gmdate('Ymd', current_time('timestamp') - 86400 * $gg));
	              $px_pageviews = round($qry_pageviews->total * 100 / $maxxday);

	              //TOTAL SPIDERS
	              $qry_spiders =$mySql->getRow(mySql::QRY_TotSpiders,gmdate('Ymd', current_time('timestamp') - 86400 * $gg));
	              $px_spiders = round($qry_spiders->total * 100 / $maxxday);

	              //TOTAL FEEDS
				  $qry_feeds =$mySql->getRow(mySql::QRY_TotFeeds,gmdate('Ymd', current_time('timestamp') - 86400 * $gg));
	              $px_feeds = round($qry_feeds->total * 100 / $maxxday);
	              $px_white = 100 - $px_feeds - $px_spiders - $px_pageviews - $px_visitors;

	              print '<td width="' . $gd . '" valign="bottom"';
	              if ($start_of_week == gmdate('w', current_time('timestamp') - 86400 * $gg))
	              {
	                  print ' style="border-left:2px dotted gray;"';
	              }
	              // week-cut
	              print "><div style='float:left;height: 100%;width:100%;font-family:Helvetica;font-size:7pt;text-align:center;border-right:1px solid white;color:black;'>
	    <div style='background:#ffffff;width:100%;height:" . $px_white . "px;'></div>
	    <div style='background:$unique_color;width:100%;height:" . $px_visitors . "px;' title='" . $qry_visitors->total . " " . __('visitors', 'statcomm')."'></div>
	    <div style='background:$web_color;width:100%;height:" . $px_pageviews . "px;' title='" . $qry_pageviews->total . " " . __('pageviews', 'statcomm')."'></div>
	    <div style='background:$spider_color;width:100%;height:" . $px_spiders . "px;' title='" . $qry_spiders->total . " " . __('spiders', 'statcomm')."'></div>
	    <div style='background:$rss_color;width:100%;height:" . $px_feeds . "px;' title='" . $qry_feeds->total . " " . __('feeds', 'statcomm')."'></div>
	    <div style='background:gray;width:100%;height:1px;'></div>
	    <br />" . gmdate('d', current_time('timestamp') - 86400 * $gg) . ' ' . gmdate('M', current_time('timestamp') - 86400 * $gg) . "</div></td>\n";
	          }
	          print '</tr></table>';

	          print '</div>';

		}

		/**
		 * Draw the Last Hits Table
		 * Updated: avoid using wpdb and sql queries directly
		 * 20120406: Improved using statcommParser
		 * From StatComm 1.6.3
		 * Improved: icons
		 * Improved: long url can be seen hovering the url
		 * Improved: link takes you to the page
		 * Improved: link to OS wikipedia
		 * Improved: link to user agent details
		 * Improved: column browser version added
         * v.1.6.60: geolocation add three new columns if activated
		 */
		private function lastHitTable()
		{
            $geoLocation=utilities::geolocationEnabled();

			$mySql= new mySql();
			$parser= new statcommParser();
			//add icon hits to Title
          //	print "<div class='wrap'><h2>" . __('Last hits', 'statcomm') . "</h2><table class='widefat'><thead><tr><th scope='col'>" . __('Date', 'statcomm') . "</th><th scope='col'>" . __('Time', 'statcomm') . "</th><th scope='col'>" . __('IP', 'statcomm') . "</th><th scope='col'>" . __('Threat', 'statcomm') . "</th><th scope='col'>" . __('Domain', 'statcomm') . "</th><th scope='col'>" . __('Page', 'statcomm') . "</th><th scope='col'>" . __('OS', 'statcomm') . "</th><th scope='col'>" . __('Browser', 'statcomm') . "</th><th scope='col'>" . __('Feed', 'statcomm') . "</th></tr></thead>";
            print "<div class='wrap'><h2>" . __('Last hits', 'statcomm') . "<font color='#e0e0e0'>" . __("(hover IP to get spy information)","statcomm") . "</font></h2><table class='widefat'><thead><tr>";
			print "<th scope='col'>" . __('Date', 'statcomm') . "</th>";
			print "<th scope='col'>" . __('Time', 'statcomm') . "</th>";
			print "<th scope='col'>" . __('IP', 'statcomm') . "</th>";
            if ($geoLocation)
            {
                print "<th scope='col'>" . __('Flag', 'statcomm') . "</th>";
                print "<th scope='col'>" . __('Region', 'statcomm') . "</th>";
                print "<th scope='col'>" . __('City', 'statcomm') . "</th>";
            }
			print "<th scope='col'>" . __('Domain', 'statcomm') . "</th>";
			print "<th scope='col'>" . __('Page', 'statcomm') . "</th>";
			print "<th></th><th scope='col'>" . __('OS', 'statcomm') . "</th>";
			print "<th></th><th scope='col'>" . __('Browser/<br/>Engine', 'statcomm') . "</th>";
			print "<th>"  . __('Version<br/>Number', 'statcomm') . "</th>";
			print "<th scope='col'>" . __('Feed', 'statcomm') . "</th>";
			print "</tr></thead>";
          	print "<tbody id='the-list'>";

          	$lastHits = $mySql->getResult(mySql::QRY_lastHits,200);

            if ($geoLocation)
            {
                $gi = GeoIP_Ctlr::geoip_open(plugin_dir_path(__FILE__) . 'def/GeoLiteCity.dat', GeoIP_Ctlr::GEOIP_STANDARD);
            }

            $counter=1; //v1.6.60: bug correction
          	foreach ($lastHits as $hit)
          	{
          	  //Get info from agent
          	  $ua=$parser->Parse($hit->agent);
              //utilities::fl("typ:{$ua['typ']}, family: {$ua['ua_family']}" );
             utilities::fl("ua", $ua);
              if ($ua['typ']=='Robot') continue;
          	  //If the feed isn't empty then we can ignore OS and Browser Version
          	  $isFeed = (empty($hit->feed))?0:1; //PHP incapable of such simple evaluations?
              print "<tr>";
              print "<td>" . utilities::conv2Date($hit->date) . "</td>";
              print "<td>{$hit->time}</td>";
              print "<td>";

               //   wp_nonce_url(admin_url( 'admin.php?page=statComm/spytooltip&id=' . $hit->id ),'statcomm')


              //adding link for tooltip
              print "<a href='#'  id='u{$hit->id}' class='ip' rel='{$hit->id}' >{$hit->ip}</a>";
              print "</td>";


              if ($geoLocation)
              {
                $record =GeoIpCity_Ctrl::GeoIP_info_by_addr($gi, $hit->ip);
                print "<td title='{$record->country_name}'</td>" . utilities::make_flag_icon($record)  . "</td>";
                print "<td>" . htmlentities ( $record->region_name) . "</td>";
                print "<td>". htmlentities($record->city) . "</td>";
              }

              print "<td>" . $hit->nation . "</td>";
              $oud=utilities::outUrlDecode($hit->urlrequested);
              print "<td><a title='$oud' href='{$hit->urlrequested}' target='_blank'>" . $this->makeEllipsis($oud, 40) . "</a></td>";

              print "<td>";
              if (!$isFeed)
              {
              	if ($hit->os != 'unknown')
              	{
			  		//print "<img style='border:0px;width:16px;height:16px;' src='" .  $ua['os_icon']  . "'/>";
                     // print "<img src='blank.gif' class='os {$ua['os_icon']}' alt='' />";
                      print utilities::make_os_icon($ua['os_icon']);
              	}
              }
			  print "</td>";

              print "<td title='{$ua['os_url']}'>";
              if (!$isFeed)
              {
              	if ($hit->os!='unknown')
              	{
              		print "<a href='" . $ua['os_url'] . "' target='_blank'>" . $hit->os . "</a>";
              	}
              }
			  print "</td>";

              print "<td>";
              if ($ua['ua_family']!='unknown')
              {
			  	//print "<img style='border:0px;width:16px;height:16px;' src='" .  $ua['ua_icon']  . "'/>";
                  print utilities::make_uas_icon($ua['ua_icon']);
              }
			  print "</td>";

              print "<td title='{$hit->agent}'>";
              if ($ua['ua_family']!='unknown')
              {
			  	print "<a href='" . $ua['ua_info_url'] . "' target='_blank'>" . $ua['ua_family'] . "</a>";
              }
			  print "</td>";
              print "<td>";
              if ($ua['ua_version']!='unknown')
              {
              	print $ua['ua_version'];
              }
              print "</td>";
              print "<td>" . $hit->feed . "</td>";
              print "</tr>";
                  $counter++;
                  if ($counter>20)break;
          }
          print "</table></div>";
          if($geoLocation)
          {
            GeoIP_Ctlr::geoip_close($gi);
          }
		}

		/**
		 * Draw last search terms
		 * 1.6.4: improved last search. Improved links
		 */
	    private function lastSearchTerms()
	    {
	      $mySql= new mySql();
          print "<div class='wrap'><h2>" . __('Last search terms', 'statcomm') . "</h2>";
		  print "<table class='widefat'><thead><tr>";
		  print "<th scope='col'>" . __('Date', 'statcomm') . "</th>";
		  print "<th scope='col'>" . __('Time', 'statcomm') . "</th>";
		  print "<th scope='col'>" . __('Terms', 'statcomm') . "</th>";
		  print "<th scope='col'>" . __('Engine', 'statcomm') . "</th>";
		  print "<th scope='col'>" . __('Result', 'statcomm') . "</th>";
		  print "</tr></thead>";
          print "<tbody id='the-list'>";
          $qry = $mySql->getResult(mySql::QRY_lastSearch,20);

          foreach ($qry as $rk)
          {

          	  $urlReq = utilities::irigetblogurl() . ((strpos($rk->urlrequested, 'index.php') === FALSE) ? $rk->urlrequested : '');
              print "<tr><td>" . utilities::conv2Date($rk->date) . "</td>";
			  print "<td>{$rk->time}</td>";
			  print "<td title='{$rk->referrer}'><a href='{$rk->referrer}'>" . urldecode($rk->search). "</a></td>";
			  print "<td>{$rk->searchengine}</td>";
			  print "<td title='{$urlReq}'><a href='{$urlReq}'>{$this->makeEllipsis($urlReq,80)}</a></td>";
			  print "</tr>\n";
          }
          print "</table></div>";

	    }

		/**
		 * Last Referrers table
		 */
		private function lastReferrers()
		{
			$mySql= new mySql();
		  	print "<div class='wrap'><h2>" . __('Last referrers', 'statcomm') . "</h2><table class='widefat'><thead><tr>";
			print "<th scope='col'>" . __('Date', 'statcomm') . "</th>";
			print "<th scope='col'>" . __('Time', 'statcomm') . "</th>";
			print "<th scope='col'>" . __('From', 'statcomm') . "</th>";
			print "<th scope='col'>" . __('Result', 'statcomm') . "</th>";
			print "</tr></thead>";
          	print "<tbody id='the-list'>";
          	$qry = $mySql->getResult(mySql::QRY_lastReferrers,get_option('home'), 20);
          	foreach ($qry as $rk)
          	{
          		$url= utilities::irigetblogurl() .
					   ((strpos($rk->urlrequested, 'index.php') === FALSE) ? $rk->urlrequested : '');
            	print "<tr><td>" . utilities::conv2Date($rk->date). "</td>";
				print "<td >{$rk->time}</td>";
				print "<td title='{$rk->referrer}'><a target='_blank' href='{$rk->referrer}'>{$this->makeEllipsis($rk->referrer, 70)}</a></td>";
				print "<td title='$url'><a href='$url'>{$this->makeEllipsis($url,70)}</a></td>";
				print "</tr>\n";
          	}
          	print "</table></div>";
		}

		/**
		 * Draw last agents table
		 * Improved 1.6.3: icons,links more information
		 * if it is a robot, os and version won't work
		 */
		private function lastAgents($querylimit="LIMIT 20")
		{
			$mySql= new mySql();
			$parser= new statcommParser();
	        print "<div class='wrap'><h2>" . __('Last agents', 'statcomm') . "</h2><table class='widefat'><thead><tr>";
		    print "<th scope='col'>" . __('Date', 'statcomm') . "</th>";
			print "<th scope='col'>" . __('Time', 'statcomm') . "</th>";
			print "<th scope='col'>" . __('Agent', 'statcomm') . "</th>";
			print "<th scope='col'>" . __('Agent Type', 'statcomm') . "</th>";
			print "<th scope='col'></th>";
			print "<th scope='col'>" . __('OS', 'statcomm') .  "</th>";
			print "<th scope='col'></th>";
			print "<th scope='col'>" . __('Browser/Engine' , 'statcomm') .  "</th>";
			print "<th scope='col'>" . __('Br.Version' , 'statcomm') .  "</th>";
			print "<th scope='col'>" . __('Spider', 'statcomm') . "</th>";
			print "</tr></thead>";

          	print "<tbody id='the-list'>";
          	$qry = $mySql->getResult(mySql::QRY_lastAgents,20);
          	foreach ($qry as $rk)
          	{
          		$ua= $parser->Parse($rk->agent);
          		$isRobot = ($ua['typ']== "Robot");
            	print "<tr>";
				print "<td>" . utilities::conv2Date($rk->date) . "</td>";
				print "<td>" . $rk->time . "</td>";
				print "<td title='{$rk->agent}'>{$this->makeEllipsis($rk->agent,60)}</td>";
				print "<td>{$ua['typ']}</td>";
				print "<td>";
				if ($ua['os_name']!='unknown')
				{
					//print "<img src='{$ua['os_icon']}'/>";
					print utilities::make_os_icon($ua['os_icon']);
				}
				print "</td>";
				print "<td>";
				if ($ua['os_name']!='unknown')
				{
					print "<a href='{$ua['os_url']}' target='_blank'>{$ua['os_name']}</a>";
				}
				print "</td>";
				print "<td>" . utilities::make_uas_icon($ua['ua_icon']) . "</td>";
				print "<td><a href='{$ua['ua_info_url']}' target='_blank'>{$ua['ua_family']}</a></td>";
				print "<td>";
				if ($ua['ua_version']!='unknown')
				{
					print "{$ua['ua_version']}";
				}
				print "</td>";
				print "<td> "  . $rk->spider . "</td>";
				print "</tr>\n";
          	}
          	print "</table></div>";
		}

		/**
		 * Draw last pages table
		 * improved: 1.6.3: links and icons
		 */
		private function lastPages($querylimit="LIMIT 20")
		{
			$mySql= new mySql();
			$parser= new statcommParser();
	    	print "<div class='wrap'><h2>" . __('Last pages', 'statcomm') .	  "</h2>";
			print "<table class='widefat'><thead><tr>";
			print "<th scope='col'>" . __('Date', 'statcomm') .  "</th>";
			print "<th scope='col'>" . __('Time', 'statcomm') . "</th>";
			print "<th scope='col'>" . __('Page', 'statcomm') .  "</th>";
			print "<th scope='col'></th>";
			print "<th scope='col'>" . __('OS', 'statcomm') . "</th>";
			print "<th scope='col'></th>";
			print "<th scope='col'>" . __('Browser', 'statcomm') . "</th>";
			print "<th scope='col'>" . __('Br.Version', 'statcomm') . "</th>";
			print "</tr></thead>";

          	print "<tbody id='the-list'>";
          	$qry = $mySql->getResult(mySql::QRY_lastPages,20);
          	foreach ($qry as $rk)
          	{
          		$ua= $parser->Parse($rk->agent);
              	print "<tr><td>" . utilities::conv2Date($rk->date) . "</td>";
				print "<td>" . $rk->time . "</td>";
			    print "<td title='" . utilities::outUrlDecode($rk->urlrequested) .
					  "'><a href='" . utilities::outUrlDecode($rk->urlrequested) .
					  "' target='_blank'>" . $this->makeEllipsis(utilities::outUrlDecode($rk->urlrequested), 60) . "</td>";

			    print "<td>";
			    if ($ua['os_name']!='unknown')
				{
					//print "<img src='{$ua['os_icon']}'/>";
                    print utilities::make_os_icon($ua['os_icon']);
				}
				print "</td>";
				print "<td>";
				if ($ua['os_name']!='unknown')
				{
			    	print "<a href='{$ua['os_url']}' target='_blank'>{$ua['os_name']}</a>";
				}
				print "</td>";
				print "<td>";
				if ($ua['ua_family']!='unknown')
				{
			    	//print "<img src='{$ua['ua_icon']}'/>";
			    	print utilities::make_uas_icon($ua['ua_icon']);
				}
				print "</td>";
				print "<td>";
				if ($ua['ua_family']!='unknown')
				{
					print "<a href='{$ua['ua_info_url']}' target='_blank'>{$ua['ua_family']}</a>";
				}
				print "</td>";
				print "<td title='{$rk->agent}'>{$ua['ua_version']}</td>";
			    print "</tr>\n";
          	}
          	print "</table></div>";
		}

		/**
		 * Draw last spiders table
		 * 1.6.3: Improved
		 */
		private function lastSpiders($querylimit="LIMIT 20")
		{
			$mySql= new mySql();
			$qry = $mySql->getResult(mySql::QRY_lastSpiders,20);
			$parser= new statcommParser();

          	print "<div class='wrap'><h2>" . __('Last spiders', 'statcomm') . "</h2>";
          	print "<table class='widefat'><thead><tr>";
          	print "<th scope='col'>" . __('Date'  , 'statcomm') . "</th>";
          	print "<th scope='col'>" . __('Time'  , 'statcomm') . "</th>";
          	print "<th scope='col'>" . __('Spider', 'statcomm') . "</th>";
          	print "<th scope='col'>" . __('Page'  , 'statcomm') . "</th>";
          	print "<th scope='col'>" . __('Agent' , 'statcomm') . "</th>";
          	print "</tr></thead><tbody id='the-list'>";

          	foreach ($qry as $rk)
          	{
          		$ua=$parser->Parse($rk->agent);
            	print "<tr><td>" . utilities::conv2Date($rk->date) . "</td>";
              	print "<td>{$rk->time}</td>";
              	print "<td><a href='{$ua['ua_info_url']}' target='_blank'>{$ua['ua_name']}</a></td>";
              	print "<td title='" .  utilities::outUrlDecode($rk->urlrequested). "'>" .
              		  $this->makeEllipsis(utilities::outUrlDecode($rk->urlrequested), 80) . "</td>";
				print "<td><img src='{$ua['ua_icon']}'/></td>";
				print "</tr>\n";
          	}
          	print "</table></div>";
		}

		/**
		 * Draw useful information about plugin
		 */
		private function footerMainPage()
		{
		print "<br />";
          //To improve: what other information should be in the footer and what information should be suppressed/configured?
          print "&nbsp;<i>" . __('StatPress table size', 'statcomm') . ": <b>" . $this->iritablesize() . "</b></i><br />";
          print "&nbsp;<i>" . __('StatPress current time', 'statcomm') . ": <b>" . current_time('mysql') . "</b></i><br />";
          print "&nbsp;<i>" . __('RSS2 url', 'statcomm') . ": <b>" . get_bloginfo('rss2_url') . ' (' . $this->extractFeedReq(get_bloginfo('rss2_url')) . ")</b></i><br />";
          print "&nbsp;<i>" . __('ATOM url', 'statcomm') . ": <b>" . get_bloginfo('atom_url') . ' (' . $this->extractFeedReq(get_bloginfo('atom_url')) . ")</b></i><br />";
          print "&nbsp;<i>" . __('RSS url', 'statcomm') . ": <b>" . get_bloginfo('rss_url') . ' (' . $this->extractFeedReq(get_bloginfo('rss_url')) . ")</b></i><br />";
          print "&nbsp;<i>" . __('COMMENT RSS2 url', 'statcomm') . ": <b>" . get_bloginfo('comments_rss2_url') . ' (' . $this->extractFeedReq(get_bloginfo('comments_rss2_url')) . ")</b></i><br />";
          print "&nbsp;<i>" . __('COMMENT ATOM url', 'statcomm') . ": <b>" . get_bloginfo('comments_atom_url') . ' (' . $this->extractFeedReq(get_bloginfo('comments_atom_url')) . ")</b></i><br />";
		}

		/**
		 * Estimation average monthly based on visitors to current day.
		 * Formula:  Part 1=(visitor this month)/(seconds this month)* 86400 = this is the visitor average by day
		 *           Part 2= Part 1 * days from this month = average estimated based on part 1
		 */
		private function calcAvgMonth($currVal,$prevVal)
		{
			$target = round($currVal / (time() - mktime(0,0,0,date('m'),date('1'),date('Y'))) * (86400 * date('t')));
          	return  $target . $this->calcPorcVar($target,$prevVal);
		}

		/**
		 * Returns porcentual variation between 2 values (formatted)
		 */
		private function calcPorcVar($currVal,$prevVal)
		{
		   if ($prevVal <> 0)
          {
              $pc = round(100 * ($currVal / $prevVal) - 100, 1);
              if ($pc >= 0)
              {
                  $pc = "+" . $pc;
              }
              return "<code> (" . $pc . "%)</code>";
          }
		}

		/**
		 * Provide statistical information about all visitors.
		 */
      function statcommDetails()
      {

          // Top days
          $this->iriValueTable("date", __('Top days', 'statcomm'), 5);

          // O.S.
          $this->iriValueTable("os", __('O.S.', 'statcomm'), 0, "", "", "AND feed='' AND spider='' AND os<>''");

          // Browser
          $this->iriValueTable("browser", __('Browser', 'statcomm'), 0, "", "", "AND feed='' AND spider='' AND browser<>''");

          // Feeds
          $this->iriValueTable("feed", __('Feeds', 'statcomm'), 5, "", "", "AND feed<>''");

          // SE
          $this->iriValueTable("searchengine", __('Search engines', 'statcomm'), 10, "", "", "AND searchengine<>''");

          // Search terms
          $this->iriValueTable("search", __('Top search terms', 'statcomm'), 20, "", "", "AND search<>''");

          // Top referrer
          $this->iriValueTable("referrer", __('Top referrer', 'statcomm'), 10, "", "", "AND referrer<>'' AND referrer NOT LIKE '%" . get_bloginfo('url') . "%'");

          // Countries
          $this->iriValueTable("nation", __('Countries (domains)', 'statcomm'), 10, "", "", "AND nation<>'' AND spider=''");

          // Spider
          $this->iriValueTable("spider", __('Spiders', 'statcomm'), 10, "", "", "AND spider<>''");

          // Top Pages
          $this->iriValueTable("urlrequested", __('Top pages', 'statcomm'), 5, "", "urlrequested", "AND feed='' and spider=''");


          // Top Days - Unique visitors
          $this->iriValueTable("date", __('Top Days - Unique visitors', 'statcomm'), 5, "distinct", "ip", "AND feed='' and spider=''");

          // Top Days - Pageviews
          $this->iriValueTable("date", __('Top Days - Pageviews', 'statcomm'), 5, "", "urlrequested", "AND feed='' and spider=''");

          // Top IPs - Pageviews
          $this->iriValueTable("ip", __('Top IPs - Pageviews', 'statcomm'), 5, "", "urlrequested", "AND feed='' and spider=''");
      }

	/**
	Main Spy functionality , to be improved.
	20120404: Performance problem detected mainly loop over hostip.info
	20120407:1.6.31 patch: bug when navigating pages. New approach is much more simple. Corrected.
	*/

      function statcommSpy()
      {
        statcommSpy::spy();
      }


/**
 * Search inside the data.
 * to improve and simplify (A LOT!)
 */
      function statcommSearch($what = '')
      {

          global $wpdb;
  		  $table_name= $wpdb->prefix . "statcomm";
          $mySql = new mySql();

          $f['urlrequested'] = __('URL Requested', 'statcomm');
          $f['agent'] = __('Agent', 'statcomm');
          $f['referrer'] = __('Referrer', 'statcomm');
          $f['search'] = __('Search terms', 'statcomm');
          $f['searchengine'] = __('Search engine', 'statcomm');
          $f['os'] = __('Operative system', 'statcomm');
          $f['browser'] = __('Browser', 'statcomm');
          $f['spider'] = __('Spider', 'statcomm');
          $f['ip'] = __('IP', 'statcomm');
?>
  <div class='wrap'><h2><?php
          _e('Search', 'statcomm');
?></h2>
  <form method=get><table>
  <?php
          for ($i = 1; $i <= 3; $i++)
          {
              print "<tr>";
              print "<td>" . __('Field', 'statcomm') . " <select name=where$i><option value=''></option>";
              foreach (array_keys($f) as $k)
              {
                  print "<option value='$k'";
                  $w=isset($_GET["where$i"])?$_GET["where$i"]:"";
                  if ($w == $k)
                  {
                      print " SELECTED ";
                  }
                  print ">" . $f[$k] . "</option>";
              }
              $g=isset($_GET["groupby$i"])?$_GET["groupby$i"]:"";
              $s=isset($_GET["sortby$i"])?$_GET["sortby$i"]:"";
              $w=isset($_GET["what$i"])?$_GET["what$i"]:"";
              print "</select></td>";
              print "<td><input type=checkbox name=groupby$i value='checked' $g> " . __('Group by', 'statcomm') . "</td>";
              print "<td><input type=checkbox name=sortby$i value='checked' $s> " . __('Sort by', 'statcomm') . "</td>";
              print "<td>, " . __('if contains', 'statcomm') . " <input type=text name=what$i value='$w'></td>";
              print "</tr>";
          }
?>
  </table>
  <br>
  <table>
  <tr>
    <td>
      <table>
        <tr><td><input type=checkbox name=oderbycount value=checked <?php
          $o=isset($_GET['oderbycount'])?$_GET['oderbycount']:"";
          print $o;
?>> <?php
          _e('sort by count if grouped', 'statcomm');
?></td></tr>
        <tr><td><input type=checkbox name=spider value=checked <?php
          $sp=isset($_GET['oderbycount'])?$_GET['oderbycount']:"";
          print $sp;
?>> <?php
          _e('include spiders/crawlers/bot', 'statcomm');
?></td></tr>
        <tr><td><input type=checkbox name=feed value=checked <?php
          $f=isset($_GET['feed'])?$_GET['feed']:"";
          print $f;
?>> <?php
          _e('include feed', 'statcomm');
?></td></tr>
<tr><td><input type=checkbox name=distinct value=checked <?php
		  $d=isset($_GET['distinct'])?$_GET['distinct']:"";
          print $d
?>> <?php
          _e('SELECT DISTINCT', 'statcomm');
?></td></tr>
      </table>
    </td>
    <td width=15> </td>
    <td>
      <table>
        <tr>
          <td><?php
          _e('Limit results to', 'statcomm');
?>
            <select name=limitquery><?php
		  $l=isset($_GET['limitquery'])?$_GET['limitquery']:"";
          if ($l > 0)
          {
              print "<option>" . $l . "</option>";
          }
?><option>1</option><option>5</option><option>10</option><option>20</option><option>50</option><option>100</option><option>250</option><option>500</option></select>
          </td>
        </tr>
        <tr><td>&nbsp;</td></tr>
        <tr>
          <td align=right><input type=submit value=<?php
          _e('Search', 'statcomm');
?> name=searchsubmit></td>
        </tr>
      </table>
    </td>
  </tr>
  </table>
  <input type=hidden name=page value='statComm/search'><input type=hidden name=statcomm_action value=search>
  </form><br>
<?php
		  $s=isset($_GET["searchsubmit"])?$_GET['searchsubmit']:"";
          if ($s)
          {
              // query builder
              $qry = "";
              // FIELDS
              $fields = "";
              for ($i = 1; $i <= 3; $i++)
              {
				$w=isset($_GET["where$i"])?$_GET["where$i"]:"";
                  if ($w != '')
                  {
                      $fields .= $w . ",";
                  }
              }
              $fields = rtrim($fields, ",");
              // WHERE
              $where = "WHERE 1=1";
              $s=isset($_GET['spider'])?$_GET['spider']:"";
              $f=isset($_GET['feed'])?$_GET['feed']:"";
              if ($s != 'checked')
              {
                  $where .= " AND spider=''";
              }
              if ($f != 'checked')
              {
                  $where .= " AND feed=''";
              }
              for ($i = 1; $i <= 3; $i++)
              {
              	  $whati=isset($_GET["what$i"])?$_GET["what$i"]:"";
              	  $wheri=isset($_GET["where$i"])?$_GET["where$i"]:"";
                  if (($whati != '') && ($wheri != ''))
                  {
                      $where .= " AND " . $wheri . " LIKE '%" . mysql_real_escape_string($whati) . "%'";
                  }
              }
              // ORDER BY
              $orderby = "";
              for ($i = 1; $i <= 3; $i++)
              {
              	  $sorti=isset($_GET["sortby$i"])?$_GET["sortby$i"]:"";
              	  $wheri=isset($_GET["where$i"])?$_GET["where$i"]:"";
                  if (($sorti == 'checked') && ($wheri != ''))
                  {
                      $orderby .= $wheri . ',';
                  }
              }

              // GROUP BY
              $groupby = "";
              for ($i = 1; $i <= 3; $i++)
              {
              	 $grupi=isset($_GET["groupby$i"])?$_GET["groupby$i"]:"";
              	 $wheri=isset($_GET["where$i"])?$_GET["where$i"]:"";
                  if (($grupi == 'checked') && ($wheri != ''))
                  {
                      $groupby .= $wheri . ',';
                  }
              }
              if ($groupby != '')
              {
                  $groupby = "GROUP BY " . rtrim($groupby, ',');
                  $fields .= ",count(*) as totale";
                  $oby =isset($_GET['oderbycount'])?$_GET['oderbycount']:"";
                  if ($oby == 'checked')
                  {
                      $orderby = "totale DESC," . $orderby;
                  }
              }

              if ($orderby != '')
              {
                  $orderby = "ORDER BY " . rtrim($orderby, ',');
              }


              $limit = "LIMIT " . $_GET['limitquery'];

			  $dst=isset($_GET['distinct'])?$_GET['distinct']:"";
              if ($dst == 'checked')
{
   $fields = " DISTINCT " . $fields;
}

              // Results
              print "<h2>" . __('Results', 'statcomm') . "</h2>";
              $sql = "SELECT $fields FROM $table_name $where $groupby $orderby $limit;";
              //  print "$sql<br>";
              print "<table class='widefat'><thead><tr>";
              for ($i = 1; $i <= 3; $i++)
              {
              	 $wheri=isset($_GET["where$i"])?$_GET["where$i"]:"";
                  if ($wheri != '')
                  {
                      print "<th scope='col'>" . ucfirst($wheri) . "</th>";
                  }
              }
              if ($groupby != '')
              {
                  print "<th scope='col'>" . __('Count', 'statcomm') . "</th>";
              }
              print "</tr></thead><tbody id='the-list'>";
              //TO IMPROVE: default type returned
              $qry = $wpdb->get_results($sql, ARRAY_N);
              foreach ($qry as $rk)
              {
                  print "<tr>";
                  for ($i = 1; $i <= 3; $i++)
                  {
                      print "<td>";
                      $wheri=isset($_GET["where$i"])?$_GET["where$i"]:"";
                      if ($wheri == 'urlrequested')
                      {
                          print utilities::outUrlDecode($rk[$i - 1]);
                      }
                      else
                      {
                      	$rki=isset($rk[$i - 1])?$rk[$i - 1]:"";
                        print $rki;
                      }
                      print "</td>";
                  }
                  print "</tr>";
              }
              print "</table>";
              print "<br /><br /><font size=1 color=gray>sql: $sql</font></div>";
          }
      }

	  /**
	  *Adds ... to end text
	  */
      function makeEllipsis($s, $c)
      {
          $res = "";
          if (strlen($s) > $c)
          {
              $res = "...";
          }
          return mb_substr ($s, 0, $c) . $res;
      }

		/**
		 * Return table size and record number
		 * 20120408 1.6.3:Improved
		 */
      function iritablesize()
      {
          $mySql= new mySql();
          $res = $mySql->getResult(mySql::QRY_tableSize);
          foreach ($res as $fstatus)
          {
              $data_lenght = $fstatus->Data_length;
              $data_rows = $fstatus->Rows;
          }
          return number_format(($data_lenght / 1024 / 1024), 2, ",", " ") . " MB ($data_rows records)";
      }


      function irirgbhex($red, $green, $blue)
      {
          $red = 0x10000 * max(0, min(255, $red + 0));
          $green = 0x100 * max(0, min(255, $green + 0));
          $blue = max(0, min(255, $blue + 0));
          // convert the combined value to hex and zero-fill to 6 digits
          return "#" . str_pad(strtoupper(dechex($red + $green + $blue)), 6, "0", STR_PAD_LEFT);
      }


/**
 * Get info data from a query
 * Updated in 1.6.3, needs a serious improve.
 */
      function iriValueTable($fld, $fldtitle, $limit = 0, $param = "", $queryfld = "", $exclude = "")
      {
          $mySql=new mySql();


          if ($queryfld == '')
          {
              $queryfld = $fld;
          }
          print "<div class='wrap'><h2>$fldtitle</h2><table style='width:100%;padding:0px;margin:0px;' cellpadding=0 cellspacing=0><thead><tr><th style='width:400px;background-color:white;'></th><th style='width:150px;background-color:white;'><u>" . __('Visits', 'statcomm') . "</u></th><th style='background-color:white;'></th></tr></thead>";
          print "<tbody id='the-list'>";

          $getCount="SELECT count($param $queryfld) as rks FROM #table# WHERE 1=1 $exclude";
          $rks = $mySql->getVar($getCount);

          if ($rks > 0)
          {
              $sql = "SELECT count($param $queryfld) as pageview, $fld FROM #table# WHERE 1=1 $exclude  GROUP BY $fld ORDER BY pageview DESC";
              if ($limit > 0)
              {
                  $sql = $sql . " LIMIT $limit";
              }
              $qry = $mySql->getResult($sql);
              $tdwidth = 450;
              $red = 131;
              $green = 180;
              $blue = 216;
              $deltacolor = round(250 / count($qry), 0);
              //      $chl="";
              //      $chd="t:";
              foreach ($qry as $rk)
              {
                  $pc = round(($rk->pageview * 100 / $rks), 1);
                  if ($fld == 'date')
                  {
                      $rk->$fld = utilities::conv2Date($rk->$fld);
                  }
                  if ($fld == 'urlrequested')
                  {
                      $rk->$fld = utilities::outUrlDecode($rk->$fld);
                  }

                  if ($fld == 'search')
                  {
                  	$rk->$fld = urldecode($rk->$fld);
                  }

                  //      $chl.=urlencode(mb_substr ($rk->$fld,0,50))."|";
                  //      $chd.=($tdwidth*$pc/100)."|";
                  print "<tr><td style='width:400px;overflow: hidden; white-space: nowrap; text-overflow: ellipsis;'>" . mb_substr ($rk->$fld, 0, 50);
                  if (strlen($rk->$fld) >= 50)
                  {
                      print "...";
                  }
                  // <td style='text-align:right'>$pc%</td>";
                  print "</td><td style='text-align:center;'>" . $rk->pageview . "</td>";
                  print "<td><div style='text-align:right;padding:2px;font-family:helvetica;font-size:7pt;font-weight:bold;height:16px;width:" . number_format(($tdwidth * $pc / 100), 1, '.', '') . "px;background:" . $this->irirgbhex($red, $green, $blue) . ";border-top:1px solid " . $this->irirgbhex($red + 20, $green + 20, $blue) . ";border-right:1px solid " . $this->irirgbhex($red + 30, $green + 30, $blue) . ";border-bottom:1px solid " . $this->irirgbhex($red - 20, $green - 20, $blue) . ";'>$pc%</div>";
                  print "</td></tr>\n";
                  $red = $red + $deltacolor;
                  $blue = $blue - ($deltacolor / 2);
              }
          }
          print "</table>\n";
          //  $chl=$this-> utf8_substr ($chl,0,strlen($chl)-1);
          //  $chd=mb_substr ($chd,0,strlen($chd)-1);
          //  print "<img src=http://chart.apis.google.com/chart?cht=p3&chd=".($chd)."&chs=400x200&chl=".($chl)."&chco=1B75DF,92BF23>\n";
          print "</div>\n";
      }



	/**
	 * Analyze the url and return an array with pairs variable=value
	 * Reference http://www.php.net/manual/es/function.parse-url.php
	 */
      function iriGetQueryPairs($url)
      {
          $parsed_url = parse_url($url);
          $tab = parse_url($url);
          $host = $tab['host'];
          if (key_exists("query", $tab))
          {
              $query = $tab["query"];
              $query = str_replace("&amp;", "&", $query);
              $query = urldecode($query);
              $query = str_replace("?", "&", $query);
              return explode("&", $query);
          }
          else
          {
              return null;
          }
      }


	/**
	 * Analyze IP return true if banned
 	*/
	  function iriCheckBanIP($arg)
      {
          if (file_exists(ABSPATH . 'wp-content/plugins/' . dirname(plugin_basename(__FILE__)) . '-custom/banips.dat'))
              $lines = file(ABSPATH . 'wp-content/plugins/' . dirname(plugin_basename(__FILE__)) . '-custom/banips.dat');
          else
              $lines = file(ABSPATH . 'wp-content/plugins/' . dirname(plugin_basename(__FILE__)) . '/def/banips.dat');
        if ($lines !== false)
        {
            foreach ($lines as $banip)
              {
               if (@preg_match('/^' . rtrim($banip, "\r\n") . '$/', $arg)){
                   return true;
               }
              }
          }
          return false;
      }

      function statcommLastMonth()
      {
          $ta = getdate(current_time('timestamp'));

          $year = $ta['year'];
          $month = $ta['mon'];

          // go back 1 month;
          $month = $month - 1;

          if ($month === 0)
          {
          	// if this month is Jan
            // go back a year
            $year  = $year - 1;
          	$month = 12;
          }

          // return in format 'YYYYMM'
          return sprintf($year . '%02d', $month);
      }

  /**
   * Create table if doesn't exists
   * It uses dbDelta function to migrate table in case it needs.
   * Update 1.6.3: moved into mySql methods
   * v1.65.: added initialization options
   *         added current lapse, independent of cmb_uarefresh
   * v1.6.70: refactored . Option settings moved to settingsAPI, it has much more sense there.
   */
  function initTableAndOptions()
  {

    If ( version_compare( get_bloginfo( 'version' ), '2.9.9', '<' ) ) {
        deactivate_plugins( basename( __FILE__ ) ); // Deactivate our plugin
        wp_die("<a href='http://www.wpgetready.com'>Statcomm</a> will work from Wordpress 3.0 and up<br/>.Please consider upgrade your Wordpress installation!<br/>");
    }
     settingsAPI::defaultValues(); //Initializate options to default values.
  	 $mySql = new mySql();
  	 $mySql->checkTable();
  }


/**
 * This function has to be improved A LOT since the new user agent detection is rendering
 * most of information obsolete.
 */
function statcommAgents()
      {
          $mySql= new mySql();
          $query = "SELECT date, MAX(time), ip, COUNT(*) as count, agent";
          $query .= " FROM #table#";
          $query .= " WHERE spider = '' AND browser = ''";
          $query .= " GROUP BY date, ip, agent";
          $query .= " ORDER BY date DESC";
          $result = $mySql->getResult($query);

          print "<div class='wrap'><h2>" . __('Unknown User Agents', 'statcomm') . "</h2>";
          print "<table class='widefat'><thead><tr>";
          print "<th scope='col'>" . __('Date', 'statcomm') . "</th>";
          print "<th scope='col'>" . __('Last Time', 'statcomm') . "</th>";
          print "<th scope='col'>" . __('IP', 'statcomm') . "</th>";
          print "<th scope='col'>" . __('Count', 'statcomm') . "</th>";
          print "<th scope='col'>" . __('User Agent', 'statcomm') . "</th>";
          print "</tr></thead><tbody id='the-list'>";

          foreach ($result as $line)
          {
            $col = 0;
            print '<tr>';
            foreach ($line as $col_value)
{
    $col++;
    if ($col == 1)
        print '<td>' . utilities::conv2Date($col_value) . '</td>';
    else if ($col == 3)
        print "<td><a href='http://www.projecthoneypot.org/ip_" . $col_value . "' target='_blank'>" . $col_value . "</a></td>";
    else
        print '<td>' . $col_value . '</td>';
}
            print '</tr>';
          }
          print '</table></div>';
      }

function extractFeedReq($url)

{
		if(!strpos($url, '?') === FALSE)
		{
        list($null, $q) = explode("?", $url);
    		list($res, $null) = explode("&", $q);
    }
    else
    {
    	$prsurl = parse_url($url);
    	// $action = (isset($_GET['statpress_action']) ? $_GET['statpress_action'] : 'default');
    	//Improvement:
    	$path=(isset($prsurl['path'])? $prsurl['path']:'');
    	$query=(isset($prsurl['query'])? $prsurl['query']:'');
    	$res = $path . $query;
    }

    return $res;
}

	/**
	 * Statcomm capture data.
	 * 1.6.3: Totally rewriten and highly improved.
	 * Question: is there a way to include debug information without stressing the system? A:Yes
     * v1.6.70: declared some missing variables
	 */
	  public function statcommAppend()
      {
        $feed = '';
        global $userdata;
        get_currentuserinfo(); //get user information, update userdata variable

        //threat analysis not currently implemented in StatComm 1.6.3. In analysis
        $threat_score=0;
        $threat_type=0;
        $os ='';
		$browser='';
		$isSpider= false;
        $searchengine="";
        $search_phrase="";

        //Get Time & IP
        $timestamp = current_time('timestamp');
        $vdate = gmdate("Ymd", $timestamp);
        $vtime = gmdate("H:i:s", $timestamp);
        $ipAddress = $_SERVER['REMOTE_ADDR'];
        //if it is banned return
        if ($this->iriCheckBanIP($ipAddress) === true)
        {
        	return '';
        }
		//calculateThread currently in analysis
        $urlRequested = utilities::requestUrl();

		//Extract extension (if any)
		$extension = pathinfo( $urlRequested, PATHINFO_EXTENSION );
		//Filter by extension, discard common filetypes
		$commonFileTypes='/ico|css|js|jpe?g|png|gif/';
		if ( !empty( $urlRequested ) && preg_match( $commonFileTypes, $extension ))
		{
			return'';
		}

		//Avoid collecting data from special folders (plugins, themes mu-,etc.)
		//1.6.4: modified specialfolder demiliter
		$specialFolders ='#(robots\.txt|wp-content/(mu-)?(plugins|themes)|wp-admin)#';
		//To improve: this filter will fail if we redefine WP_CONTENT_DIR & WP_CONTENT_URL
		// and/or also WP_PLUGIN_DIR, WP_PLUGIN_URL. Following versions will refine the concept
		if ( preg_match( $specialFolders,$urlRequested ) )
		{
			return '';
		}

        $referrer = (isset($_SERVER['HTTP_REFERER']) ? htmlentities($_SERVER['HTTP_REFERER']) : '');
        $userAgent = (isset($_SERVER['HTTP_USER_AGENT']) ? htmlentities($_SERVER['HTTP_USER_AGENT']) : '');
        //Analyze and extract relevant data.
		$parser= new statcommParser();
		$agent = $parser->Parse($userAgent);
        $spider ="";
		$options = settingsAPI::getOptions();

        if ($agent['typ'] == self::ROBOT)
        {
		  	$spider = $agent['ua_family'];
		  	$os='';
		  	$browser='';
        	//Check if we don't want to collect spiders
			if ($options["chk_no_spiders"]=='on')
			{
				return '';
			}
        }
        else //if not a Spider, is a feed?
        {
        	$prsurl = parse_url(get_bloginfo('url'));
			//return feedType if it is a feed, empty if not
		    $feed = utilities::feedType($prsurl['scheme'] . '://' . $prsurl['host'] . $_SERVER['REQUEST_URI']);
            // Get OS and browser
            $os = $agent['os_name'];
            $browser = $agent['ua_family']; //or it can be ua_version but it has far more details
            //get search_phrase using searchterms
            $pathDefinitionsFile=plugin_dir_path(__FILE__) . 'def';
            utilities::fl("pathDefFile:", $pathDefinitionsFile);
            list($searchengine, $search_phrase) = $this->searchTerm($referrer,$pathDefinitionsFile . '/searchterm.ini');
        }

		  //if is a spider, we get feed='', search_phrase='',os='' and browser =''
		  // Auto-delete visits if settings are active. To improve: how about performance here?
		  //$wpdb->show_errors(); //Activate it for trace sql problems
		 $mySql= new mySql();
      	if ($options["cmb_delete_spiders"] != 'Never delete!')
      	{
         	$t = gmdate("Ymd", strtotime('-' . $options["cmb_delete_spiders"]));
         	//Attention that this would need a new expansion in mysql class.
         	$results = $mySql->setQry(mySql::QRY_AutoDelSpider, $t);
      	}
      	if ($options["cmb_delete_visitors"] != 'Never delete!')
      	{
        	$t = gmdate("Ymd", strtotime('-' . $options["cmb_delete_visitors"]));
        	$results = $mySql->setQry(mySql::QRY_AutoDel, $t);
      	}
      	if ((!is_user_logged_in()) or ($options["chk_logged"]=='on'))
      	{
            $ud=isset($userdata->user_login)?$userdata->user_login:"";
      		$insert = "INSERT INTO #table# " .
			"(date,time,ip,urlrequested,agent,referrer,search,nation,os,browser,searchengine,spider,feed,user,threat_score,threat_type,timestamp) " .
			"VALUES ('$vdate','$vtime','$ipAddress','" .
			mysql_real_escape_string($urlRequested) . "','" .
			mysql_real_escape_string(strip_tags($userAgent)) . "','" .
			mysql_real_escape_string($referrer) . "','" .
			mysql_real_escape_string(strip_tags($search_phrase)) . "','" .
			utilities::iriDomain($ipAddress) . "','" .
			mysql_real_escape_string($os) . "','" .
			mysql_real_escape_string($browser) .
			"','$searchengine','$spider','$feed','$ud',$threat_score,$threat_type,'$timestamp')";
        	$results = $mySql->setQry($insert);
       	}
      }

	/**
	 * Attempt to extract search parameters if the referrer is a search engine.
	 */
	private function searchTerm( $referrer, $pathSearchTerm ) {
		if ( empty( $referrer ) || ! file_exists( $pathSearchTerm ) )
			return FALSE;

		//Process searchterms and sections
		$data = parse_ini_file( $pathSearchTerm , TRUE );
		foreach ( $data as $url => $info ) {
			//if doesn't match try the next one
			if ( strpos( $referrer, $url ) === FALSE )
				continue;

			//We get a  partial match,get only the query to process
			$qryStr = parse_url( $referrer, PHP_URL_QUERY );
			//empty? end the analysis
			if (empty($qryStr))
				return FALSE;
			//decode properly and get an parameter array
			$qryParts = explode( '&', html_entity_decode( urldecode( $qryStr ) ) );
			$i = count( $qryParts );
			//Examine the array
			while ( $i-- ) {
				//get every variable to examination $parts[0] variable name, $part[1] variable value
				$parts = explode( '=', $qryParts[$i] );
				//There are few cases where engine uses different search term parameters.
				//As matter of fact only google , see searchterm.ini
				if ( is_array( $info['query'] ) ) {
					$queries = count( $info['query'] );
					while ( $queries-- ) {
						if ( $parts[0] == $info['query'][$queries] )
							return array( $info['engine'], htmlentities( $parts[1], ENT_QUOTES ) );
					}
				}
				else {
					//if variable name matches , return array with engine name, and searched value
					if ( $parts[0] == $info['query'] )
						return array( $info['engine'], htmlentities( $parts[1], ENT_QUOTES ) );
				}
			}

		}
		return FALSE;
	}

		/**
		 * Provide localization for the plugin
		 * 1.6.4: update deprecated function.
		 */
		public function loadTextDomain() {
            utilities::fl("Text Domain",dirname(plugin_basename(__FILE__)) . '/locale/');
    		load_plugin_textdomain('statcomm',false,  dirname(plugin_basename(__FILE__)) . '/locale');
		}


}